# AMPL implementation of IBA exercise 7.2 on shortest path

set nodes;
param source symbolic in nodes;
param destination symbolic in nodes;
param distance {nodes,nodes};

var x {i in nodes, j in nodes} >= 0;

minimize total_distance:
  sum {i in nodes, j in nodes} distance[i,j] * x[i,j];

subject to flow_out:
  sum {j in nodes diff {source}} x[source,j] = 1;

subject to in_out {k in nodes diff {source,destination}}:
  sum {i in nodes diff {destination}} x[i,k] = sum {j in nodes diff {source}} x[k,j];